package com.iamberry.wechat.face.apparatus;

import com.iamberry.wechat.core.entity.apparatus.Apparatus;
import com.iamberry.wechat.core.entity.member.Member;
import com.iamberry.wechat.core.entity.page.PageRequest;
import com.iamberry.wechat.core.entity.page.PagedResult;
import com.iamberry.wechat.core.entity.product.ProductRelatedRstProduce;

import java.util.List;

/**
 * Created by liuzhiwei on 2017/12/28.
 */
public interface ApparatusService {

    /**
     * 分页查询机器列表
     * @param apparatus
     * @return
     */
    List<Apparatus> listApparatusPage(Apparatus apparatus);

    /**
     * 分页查询机器列表
     * @param pageRequest
     * @return
     */
    public PagedResult<Apparatus> listApparatusPageByAdmin(PageRequest<Apparatus> pageRequest);

    /**
     * 添加机器信息
     * @param apparatus
     * @return
     */
    Integer addApparatus(Apparatus apparatus);

    /**
     * 注册会员
     * @param apparatus
     * @return
     */
    boolean registerMember(Apparatus apparatus, Member member);

    /**
     * 根据openid和条形码查询单个机器信息
     * **/
    Apparatus getApparatus(Apparatus apparatus);

    /**
     * 根据RST产品id和查询颜色id
     * **/
    Integer getColorIdByProductId(String productId);

    /**
     * 添加待入账积分统一调用该接口
     * @param openId
     * @param IntegralType 1.新注册会员送一百积分  2.新增牙刷赠送400积分 3.购买牙刷，赠送积分
     * @param orderAllIntegral  订单金额  IntegralType为3时有值
     * @param orderId  订单id  IntegralType为3时有值
     * @return
     */
    boolean addStayIntegral(String openId,Integer IntegralType,Integer orderAllIntegral,String orderId,Integer cololId);

    /**
     * 添加产品颜色与pts产品关联信息
     */
    Integer addColorIdByProductId(ProductRelatedRstProduce productRelatedRstProduce);

    /**
     * 删除牙刷
     * @param code
     * @return
     */
    Integer delTooth(String code);
}
