package com.iamberry.wechat.service.coupon;

import com.iamberry.wechat.core.entity.coupon.CouponColor;
import com.iamberry.wechat.face.coupon.CouponColorService;
import com.iamberry.wechat.service.mapper.CouponColorMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 *  优惠券对应颜色接口
 * @author xm
 * @Date 2019-05-15
 */
@Service
public class CouponColorServiceImpl  implements CouponColorService {
    @Autowired
    private CouponColorMapper couponColorMapper;
    /**
     * 获取集合
     * @param  couponColor
     * @return List
     */
    @Override
    public List<CouponColor> getCouponColorList(CouponColor  couponColor){
        return  couponColorMapper.getCouponColorList(couponColor);
    }
    /**
     * 查询单条数据
     * @param  id
     * @return  couponColor
     */
    @Override
    public  CouponColor  getCouponColorById(Integer  id){
        return  couponColorMapper.getCouponColorById(id);
    }
    /**
     * 增加数据
     * @param  couponColor
     * @return Integer
     */
    @Override
    public  Integer  save(CouponColor  couponColor){
        return  couponColorMapper.save(couponColor);
    }
    /**
     * 修改数据
     * @param  couponColor
     * @return Integer
     */
    @Override
    public  Integer  update(CouponColor  couponColor){
        return  couponColorMapper.update(couponColor);
    }
    /**
     * 删除数据
     * @param  id
     * @return Integer
     */
    @Override
    public  Integer  delete(Integer  id){
        return  couponColorMapper.delete(id);
    }
    /**
     * 增加数据 <集合>
     * @param  couponColorList
     * @return Integer
     */
    @Override
    public  Integer  saveList(List<CouponColor>  couponColorList){
        return  couponColorMapper.saveList(couponColorList);
    }
}