package com.iamberry.wechat.service.coupon;

import java.util.List;
import java.util.Objects;

import com.iamberry.wechat.core.entity.cart.CartDto;
import com.iamberry.wechat.core.entity.coupon.CouponColor;
import com.iamberry.wechat.service.mapper.CouponColorMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.iamberry.wechat.core.entity.coupon.CouponItem;
import com.iamberry.wechat.core.entity.coupon.CouponItemDto;
import com.iamberry.wechat.face.coupon.CouponItemService;
import com.iamberry.wechat.service.mapper.CouponItemMapper;
import com.iamberry.wechat.tools.StrUtils;
/**
 * 优惠券类型 service实现
 * 2016年7月6日
 * @author Administrator
 *
 */
@Service
public class CouponItemServiceImpl implements CouponItemService {
	@Autowired
	private CouponItemMapper couponItemMapper;
	@Autowired
	private CouponColorMapper couponColorMapper;
	
	public List<CouponItemDto> getCouponItemDtoList(CouponItemDto couponItemDto) {
		return couponItemMapper.getCouponItemDtoList(couponItemDto);
	}

	
	public Integer getCouponItemCount(CouponItemDto couponItemDto) {
		// TODO Auto-generated method stub
		return couponItemMapper.getCouponItemCount(couponItemDto);
	}

	
	public Integer insertCouponItem(CouponItem couponItem) {
		// TODO Auto-generated method stub
		String uuidStr = StrUtils.getUUID();
		couponItem.setCouponItemId(uuidStr);
		return couponItemMapper.insertCouponItem(couponItem);
	}

	
	public CouponItemDto getCouponItemById(String couponItemId) {
		// TODO Auto-generated method stub
		return couponItemMapper.getCouponItemById(couponItemId);
	}

	
	public Integer updateCouponItemById(CouponItem couponItem) {
		// TODO Auto-generated method stub
		return couponItemMapper.updateCouponItemById(couponItem);
	}

	
	public Integer updateCouponItemList(List<CouponItem> couponItemList) {
		// TODO Auto-generated method stub
		return couponItemMapper.updateCouponItemList(couponItemList);
	}

	@Override
	public Integer getIsReceive(String openId) {
		return couponItemMapper.getIsReceive(openId);
	}

	@Override
	public Integer isReceive(CouponItem couponItem) {
		return couponItemMapper.isReceive(couponItem);
	}

	@Override
	public Integer userCouponNum(CouponItem couponItem) {
		return couponItemMapper.userCouponNum(couponItem);
	}

	@Override
	public Integer allCouponItemNumber(CouponItem couponItem) {
		return couponItemMapper.allCouponItemNumber(couponItem);
	}

	@Override
	public boolean isUniversal(Integer couponId, List<CartDto> cartDtoList) {
		boolean flag = false;
		CouponColor couponColor= new CouponColor();
		couponColor.setCouponId(couponId);
		List<CouponColor> couponColorList = couponColorMapper.getCouponColorList(couponColor);
		for (CouponColor cc:couponColorList) {
			for (CartDto cd:cartDtoList) {
				if(Objects.equals(cc.getColorId(), cd.getCartColorId())){
					flag = true;
				}
			}
		}
		return flag;
	}

}
