package com.iamberry.wechat.handles.integral;


import com.iamberry.wechat.core.entity.ResultMsg;
import com.iamberry.wechat.core.entity.member.Member;
import com.iamberry.wechat.core.entity.page.PageRequest;
import com.iamberry.wechat.core.entity.page.PagedResult;
import com.iamberry.wechat.face.home.HomeService;
import com.iamberry.wechat.face.integral.UseIntegralService;
import com.iamberry.wechat.face.member.MemberService;
import com.iamberry.wechat.face.wechat.WeChatService;
import com.iamberry.wechat.tools.NameUtils;
import com.iamberry.wechat.tools.ResultInfo;
import com.iamberry.wechat.tools.SendMessageUtil;
import com.iamberry.wechat.tools.WeixinUtil;
import net.sf.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 会员积分使用 Controller
 */
@Controller
//@RequestMapping("/otherIntegral")
public class OtherIntegralHandler {
    private Logger logger = LoggerFactory.getLogger(OtherIntegralHandler.class);

    @Autowired
    private UseIntegralService useIntegralService;
    @Autowired
    private MemberService memberService;
    @Autowired
    private SendMessageUtil sendMessageUtil;

    @Autowired
    private HomeService homeService;
    /**
     * 获取等级积分
     * @param req
     * @return
     */
//    @RequestMapping("/activity")
//    @ResponseBody
//    public ResultMsg rankRule(HttpServletRequest req){
//        Map map = new HashMap();
//
//        boolean isSuccess = true;
//
//        boolean flag = true;
//        Integer totalNum = 0;
//        Integer pageNO=1;
//        Integer pageSize=10;
//        do {
//            logger.info("====pageNO："+ pageNO +"=====pageSize:"+ pageSize +"=========");
//            PageRequest<Member> pageRequest = new PageRequest<>(new Member(), pageNO, pageSize, totalNum == 0);
//            PagedResult<Member> pagedResult = memberService.listMemberPage(pageRequest);
//            List<Member> memberList = pagedResult.getDataList();
//
//            if(memberList != null && memberList.size() > 0){
//                for (Member member : memberList) {
//                    logger.info("====第："+ pageNO*pageSize +"条=====");
//
//                    Integer integral = 0;   //积分
//                    try{
//                        integral = useIntegralService.activityPointChange(member);
//                    }catch (Exception e){
//                        logger.info("********用户id：" + member.getUserOpenid()+"更改积分失败");
//                        map.put(member.getUserOpenid(),e.getMessage());
//                        e.printStackTrace();
//                        isSuccess = false;
//                    }
//                    if(integral > 0){
//                        try {
//                            if(member.getUserNickname() == null || "".equals(member.getUserNickname())){
//                                refreshUserInfo(member.getUserOpenid());
//                            }
//                            sendMessageUtil.pointChange(
//                                    "积分变更通知",
//                                    member.getUserNickname(),
//                                    "积分增加"+integral,
//                                    "积分用于积分商城，可至个人中心-积分列表查看变动；也可在公众号对话框输入“积分变动”，了解积分政策详情。",
//                                    member.getUserOpenid(),
//                                    ResultInfo.INDEX_INTERGRAL
//                            );
//                        }catch (Exception e){
//                            e.printStackTrace();
//                        }
//                    }
//                }
//            }else{
//                break;
//            }
//
//            if(pageNO > 100){
//                break;
//            }
//
//            pageNO++;
//        }while (flag);
//
//        ResultMsg rm=new ResultMsg();
//        if(isSuccess){
//            rm.setStatus(true);
//            rm.setResultCode(ResultInfo.SUCCESSCODE);
//        }else{
//            rm.setStatus(false);
//            rm.setResultCode(ResultInfo.ERRORCODE);
//        }
//        rm.setMessage(NameUtils.getConfig("SUCCESSINFO"));
//        rm.setData(map);
//        return rm;
//    }


    /**
     * 更新微信用户信息
     * 2016年11月17日
     */
    private Member refreshUserInfo(String openId){
        System.out.println("====更新用户信息"+openId);
        JSONObject jsonObject = WeixinUtil.getUserInfo(openId);
        String sex = jsonObject.getString("sex");
        String city = jsonObject.getString("city");
        String country = jsonObject.getString("country");
        String province = jsonObject.getString("province");
        String nickname = jsonObject.getString("nickname");
        String headimgurl = jsonObject.getString("headimgurl");

        Member member = homeService.selectMemberInfoByOpenId(openId);
        //赋值&更新会员数据
        if (member != null && member.getUserId() != null) {
            member.setUserOpenid(openId);
            member.setUserNickname(nickname);
            member.setUserSex(Integer.parseInt(sex));
            member.setUserAddr(country+"-"+province+"-"+city);
            member.setUserHead(headimgurl);
            //userIsBought 暂存旧的关注状态
            member.setUserIsBought(member.getUserStatus() == null ? 1 : member.getUserStatus());
            member.setUserStatus(2);
            homeService.updateWechatMemberInfoByByOpenid(member);
        } else {
            member = new Member();
            member.setUserNickname(nickname);
            member.setUserSex(Integer.parseInt(sex));
            member.setUserAddr(country+"-"+province+"-"+city);
            member.setUserHead(headimgurl);
            member.setUserStatus(2);
            member.setUserOpenid(openId);
            member.setUserIsBought(1);
            member.setUserIsFlag(1);
            homeService.insertMemberInfo(member);
        }
        return member;
    }




}
