package com.iamberry.wechat.handles.order;

import com.iamberry.app.tool.log.RatFWLogger;
import com.iamberry.wechat.core.entity.ResultMsg;
import com.iamberry.wechat.core.entity.WechatUtils;
import com.iamberry.wechat.core.entity.cart.CartDto;
import com.iamberry.wechat.core.entity.cart.OrderPayDto;
import com.iamberry.wechat.core.entity.cart.SendPayDto;
import com.iamberry.wechat.core.entity.cart.TempOrderDto;
import com.iamberry.wechat.core.entity.channel.ChannelPrice;
import com.iamberry.wechat.core.entity.channel.ChannelRebate;
import com.iamberry.wechat.core.entity.channel.ChildChannel;
import com.iamberry.wechat.core.entity.channel.MainChannel;
import com.iamberry.wechat.core.entity.coupon.*;
import com.iamberry.wechat.core.entity.customized.CustomizedTooth;
import com.iamberry.wechat.core.entity.gift.SettlementGift;
import com.iamberry.wechat.core.entity.integral.StayIntegral;
import com.iamberry.wechat.core.entity.member.Member;
import com.iamberry.wechat.core.entity.order.Order;
import com.iamberry.wechat.core.entity.order.OrderItem;
import com.iamberry.wechat.core.entity.pay.PayResult;
import com.iamberry.wechat.core.entity.product.Product;
import com.iamberry.wechat.core.entity.product.ProductColor;
import com.iamberry.wechat.face.admin.SystemService;
import com.iamberry.wechat.face.cart.CartService;
import com.iamberry.wechat.face.cart.ProductInfoService;
import com.iamberry.wechat.face.channel.ChannelPriceService;
import com.iamberry.wechat.face.channel.ChannelRebateService;
import com.iamberry.wechat.face.channel.ChildChannelService;
import com.iamberry.wechat.face.channel.MainChannelService;
import com.iamberry.wechat.face.coupon.CouponItemService;
import com.iamberry.wechat.face.coupon.CouponTypeService;
import com.iamberry.wechat.face.coupon.SalesActivitiesService;
import com.iamberry.wechat.face.customized.CustomizedToothService;
import com.iamberry.wechat.face.gift.SettlementGiftService;
import com.iamberry.wechat.face.home.HomeService;
import com.iamberry.wechat.face.integral.UseIntegralService;
import com.iamberry.wechat.face.member.CashLogService;
import com.iamberry.wechat.face.member.MemberService;
import com.iamberry.wechat.face.mq.EfastOrderService;
import com.iamberry.wechat.face.order.AdminOrderService;
import com.iamberry.wechat.face.pay.PayService;
import com.iamberry.wechat.face.porduct.ProductColorService;
import com.iamberry.wechat.face.qrcode.TemporaryQrcodeService;
import com.iamberry.wechat.face.reback.RebackServices;
import com.iamberry.wechat.handles.mq.MQServiceProxy;
import com.iamberry.wechat.tools.NameUtils;
import com.iamberry.wechat.tools.OrderNOUtil;
import com.iamberry.wechat.tools.ResultInfo;
import com.iamberry.wechat.tools.ValidatorUtil;
import com.iamberry.wechat.utils.ActivityUtil;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author 何秀刚
 * Class Description: 订单hander
 * Create Date:2016年4月20日
 * Update Date:2016年4月20日
 */
@Controller
@RequestMapping("/wechat/order")
public class OrderHandler {
	@Autowired
	private RatFWLogger ratFWLogger;
	@Autowired
	private CartService cartService;
	@Autowired
	private HomeService homeService;
	@Autowired
	private SystemService systemService;
	@Autowired
	private ValidatorUtil validatorUtil;
	@Autowired
	private PayService payService;
	@Autowired
	private MQServiceProxy mQservice;
	@Autowired
	private MemberService memberService;
	@Autowired
	CouponItemService couponItemService;
	@Autowired
	CouponTypeService couponTypeService;
	@Autowired
	CashLogService cashLogService;
	@Autowired
	private RebackServices rebackServices;
	@Autowired
	private ProductInfoService productInfoService;
	@Autowired
	private TemporaryQrcodeService temporaryQrcodeService;
	@Autowired
	private ProductColorService productColorService;
	@Autowired
	private UseIntegralService useIntegralService;
	@Autowired
	private EfastOrderService efastOrderService;
	@Autowired
	private CustomizedToothService customizedToothService;
	@Autowired
	private AdminOrderService adminOrderService;
	@Autowired
	private ChannelPriceService channelPriceService;
	@Autowired
	private ChannelRebateService channelRebateService;
	@Autowired
	private MainChannelService mainChannelService;
	@Autowired
	private ChildChannelService childChannelService;
	@Autowired
	private ActivityUtil activityUtil;
	@Autowired
	private SalesActivitiesService salesActivitiesService;
	@Autowired
	private SettlementGiftService settlementGiftService;

	/**
	 * 支付前，调用方法
	 * @param request
	 * @return
	 * @throws Exception
	 */
	@ResponseBody
	@RequestMapping(value = "/payBefore")
	public ResultMsg payBefore(HttpServletRequest request,
							   @RequestParam(value = "channelType",defaultValue = "0") Integer channelType,
							   @RequestParam(value = "channelId",defaultValue = "0") Integer channelId
	) throws Exception {

		ResultMsg msg = new ResultMsg();
		msg.setResultCode(ResultInfo.ERRORCODE);

		OrderPayDto dto = new OrderPayDto();
		// 用户信息
		String openId  = WechatUtils.getUserBySession(request).getUserOpenid();
		Member member = memberService.getMemberByUserOpenId(openId);
		String cartIds = request.getParameter("cartIds");
		//普通牙刷就是购物车的id，  定制牙刷为定制表（tb_iamberry_customized_tooth）的id
//		String isCustomize = request.getParameter("isCustomize");	// 1：普通牙刷购买  2：定制牙刷购买
//		if(isCustomize == null || "".equals(isCustomize)){	//默认为普通牙刷
//			isCustomize = "1";
//		}

		if(channelType > 0 && channelId > 0){
			if(channelType == 1){
				MainChannel mainChannel = mainChannelService.getMainChannelById(channelId);
				dto.setChannelName(mainChannel.getMainChannelName());
			}else{
				ChildChannel childChannel = childChannelService.getChildChannelById(channelId);
				dto.setChannelName( childChannel.getChildChannelName());
			}
		}

		if (cartIds == null) {
			msg.setMessage(ResultInfo.cartEmptyError);
			return msg;
		}
		cartIds = cartIds.trim();
		/*获取购物项--start*/
		String [] cartList = cartIds.split("-");
		if (cartList == null || cartList.length <= 0) {
			msg.setMessage(ResultInfo.cartEmptyError);
			return msg;
		}
		// 转化 String 类型的购物车ID集合 --> Integer 类型的购物车集合
		Integer[] cartIntList = new Integer[cartList.length];
		for (int i = 0; i < cartList.length; i++) {
			String string = cartList[i];
			try {
				cartIntList[i] = Integer.parseInt(string);
			} catch (Exception e) {
				msg.setMessage(e.getMessage());
				return msg;
			}
		}
		if (cartIntList.length <= 0) {
			msg.setMessage(ResultInfo.cartEmptyError);
			return msg;
		}
		// 根据购物车ID，查询数据库中对应的产品信息（ID、产品状态）
		List<CartDto> cartDtos = cartService.selectCartItemByListId(cartIntList);
		if (cartDtos == null || cartDtos.size() <= 0) {
			msg.setMessage(ResultInfo.cartEmptyError);
			return msg;
		}

		//牙刷个数
		Integer toothAllbrush = 0;
		//成人牙刷个数
		Integer toothAuthbrush = 0;
		//儿童牙刷个数
		Integer toothKidsbrush = 0;
		//lips牙刷刷头数量 - 单只
		Integer toothLipsbrushHeadNum = 0;
		//北欧和轻奢刷头数量 - 单只
		Integer toothRPbrushHeadNum = 0;
		//儿童刷头数量 - 单只
		Integer toothKidbrushHeadNum = 0;
		//组合套装刷头数量
		Integer toothComBinbrushHeadNum = 0;
		// 判断当前提交的购物车ID，有多少产品在售
		// 支付金额
		int total = 0;
		// 需要购买牙刷到某种金额
		int toothbrushTotal = 0;
		// 产品数量
		int sum = 0;
		List<CartDto> tempCarts = new ArrayList<CartDto>(cartDtos.size());
		for (CartDto cd : cartDtos) {
			if((cd.getColorAllNum() - cd.getColorSoldNum()) < 1){
				msg.setMessage(ResultInfo.cartNoNumError);
				return msg;
			}
			if (cd.getProductStatus() == null || cd.getProductStatus() != 1) {
				msg.setMessage(ResultInfo.cartNoStatusError);
				return msg;
			}

			//设置默认值-不能自提
			cd.setIsSelfLifting(2);

			//上朵分销，查看是否为分销,分销则获取分销价格赋值
			if(channelType > 0 && channelId > 0){
				ChannelPrice channelPrice = channelPriceService.getChannelPriceByChannel(channelId,channelType,cd.getCartColorId());
				if(channelPrice != null){
					//因结算页面都是取price，所以都赋值优惠价
					cd.setProductPrice( channelPrice.getChannelPriceOffer());
					cd.setProductDiscount( channelPrice.getChannelPriceOffer());
					cd.setIsSelfLifting(1);
				}
			}

			total += cd.getCartNum() * cd.getProductPrice();
			sum++;
			tempCarts.add(cd);
			switch (cd.getColorToothType()){
				//牙刷分类
				case 1:
					//1：赠品(非牙刷，非刷头)
					break;
				case 2:
					//2：成人牙刷
					toothAuthbrush += cd.getCartNum();
					toothAllbrush += cd.getCartNum();
					toothbrushTotal += cd.getCartNum()*cd.getProductPrice();
					break;
				case 3:
					// 3：儿童牙刷
					toothKidsbrush += cd.getCartNum();
					toothAllbrush += cd.getCartNum();
					toothbrushTotal += cd.getCartNum()*cd.getProductPrice();
					break;
				case 4:
					//4：亲子款（成人+儿童）
					toothAllbrush += cd.getCartNum();
					toothbrushTotal += cd.getCartNum()*cd.getProductPrice();
					break;
				case 5:
					//5：刷头(lips)
					toothLipsbrushHeadNum += cd.getCartNum();
					break;
				case 6:
					//6:刷头(儿童)
					toothKidbrushHeadNum += cd.getCartNum();
					break;
				case 7:
					//7:刷头(北欧+轻奢)
					toothRPbrushHeadNum += cd.getCartNum();
					break;
				case 8:
					//8:刷头(套装)
					toothComBinbrushHeadNum += cd.getCartNum();
					break;
				default:
					break;
			}
		}

		ActivityDate activityDate = activityUtil.doubleTwelve();
		if(channelType > 0 && channelId > 0){
			///非分销渠道，才能有促销
			activityDate.setStatus(false);
		}else{
			if(activityDate.isStatus()){
				/*满减*/
				Integer promotionAmout = fullReduc(activityDate,tempCarts);
				//促销之后的金额 -- 总金额减去满减，满减的优先级高一些
				//满赠
				giftCart(tempCarts);
			}
		}
		dto.setActivityDate(activityDate);

		if (sum <= 0) {
			msg.setMessage(ResultInfo.cartEmptyError);
			return msg;
		}
		//查询所有 未过期 优惠券
		CouponItemDto cDto = new CouponItemDto();
		cDto.setUseropenid(member.getUserOpenid());
		cDto.setCouponUseStatus(1);
		cDto.setBeginDate(new Date());
		List<CouponItemDto> couponItemDtoList = couponItemService.getCouponItemDtoList(cDto);
		List<CouponItemDto> list = new ArrayList<>();
		for(CouponItemDto couponItemDto : couponItemDtoList){
			boolean flag = true;

			if(couponItemDto.getCouponIsUniversal() == 2){
				// 判断部分产品能使用的优惠券
				if(!couponItemService.isUniversal(couponItemDto.getCouponId(),cartDtos)){
					flag = false;
				}
			}

			//必须购买牙刷
			if(couponItemDto.getCouponIsPurchase() == 1 && toothAllbrush < 1){
				flag = false;
			}
			Map<Integer, CartDto> cartMap = null;
 			switch (couponItemDto.getCouponId()){
				case 20000:
					//刷头抵扣卷
					if(member.getUserIdentity() != 1){
						//不为会员或者没有牙刷刷头都无法使用
						if(toothAllbrush < 1){
							flag = false;
						}
					}
					if(toothKidbrushHeadNum < 1 && toothRPbrushHeadNum < 1 && toothLipsbrushHeadNum < 1){
						flag = false;
					}
					break;
				case 20004:
					//lips刷头抵扣卷
					if(member.getUserIdentity() != 1){
						//不为会员或者没有牙刷刷头都无法使用
						if(toothAllbrush < 1){
							flag = false;
						}
					}
					if(toothLipsbrushHeadNum < 1){
						flag = false;
					}
					break;
				case 40000:
					//刷头优惠券 60
					if(member.getUserIdentity() != 1){
						//不为会员或者没有牙刷刷头都无法使用
						if(toothAllbrush < 1){
							flag = false;
						}
					}
					if(toothKidbrushHeadNum < 1 && toothRPbrushHeadNum < 1){
						flag = false;
					}
					break;
				case 110000:
					//上朵年货节-电动牙刷8折券
					if(toothAllbrush < 1){
						flag = false;
					}
					break;
				case 110001:
					//上朵年货节-刷头9折券
				case 110002:
					//上朵年货节-刷头8.5折券
				case 110003:
					//上朵年货节-刷头8折券
				case 110004:
					//上朵年货节-刷头7.5折券
					if(toothKidbrushHeadNum < 1 && toothRPbrushHeadNum < 1 && toothLipsbrushHeadNum < 1 && toothComBinbrushHeadNum < 1){
						flag = false;
					}
					break;
				case 110005:
					// 牙刷买1送1(寻找两个以上的牙刷，单价最高)
					cartMap = new HashMap<>(tempCarts.size());
					for (int i = 0; i < tempCarts.size(); i++) {
						CartDto cart = tempCarts.get(i);
						if (cart.getColorToothType() >= 2 && cart.getColorToothType() <= 4) {
							// 购买牙刷
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp = new CartDto();
								BeanUtils.copyProperties(cart, temp);
								cartMap.put(cart.getCartProductId(), temp);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						flag = false;
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponItemDto.getCouponReduce()) {
							couponItemDto.setCouponReduce(cart.getProductPrice());
						}
					});
					if (couponItemDto.getCouponReduce() <= 0) {
						flag = false;
					}
					break;
				case 110006:
					// 刷头买1送1(寻找单价最高的刷头，2个以上)
					cartMap = new HashMap<>(tempCarts.size());
					for (int i = 0; i < tempCarts.size(); i++) {
						CartDto cart = tempCarts.get(i);
						if (cart.getColorToothType() >= 5 && cart.getColorToothType() <= 8) {
							// 购买牙刷
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp = new CartDto();
								BeanUtils.copyProperties(cart, temp);
								cartMap.put(cart.getCartProductId(), temp);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						flag = false;
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponItemDto.getCouponReduce()) {
							couponItemDto.setCouponReduce(cart.getProductPrice());
						}
					});
					if (couponItemDto.getCouponReduce() <= 0) {
						flag = false;
					}
					break;
                case 500004:
					// P系列牙刷 买一送一
					cartMap = new HashMap<>(tempCarts.size());
					for (int i = 0; i < tempCarts.size(); i++) {
						CartDto cart = tempCarts.get(i);
						if (cart.getCartColorId() >= 42 && cart.getCartColorId() <= 45) {
							// 购买牙刷
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp = new CartDto();
								BeanUtils.copyProperties(cart, temp);
								cartMap.put(cart.getCartProductId(), temp);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						flag = false;
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponItemDto.getCouponReduce()) {
							couponItemDto.setCouponReduce(cart.getProductPrice());
						}
					});
					if (couponItemDto.getCouponReduce() <= 0) {
						flag = false;
					}
					break;
                case 500005:
					// Lips系列牙刷 买一送一
					cartMap = new HashMap<>(tempCarts.size());
					for (int i = 0; i < tempCarts.size(); i++) {
						CartDto cart = tempCarts.get(i);
						if (cart.getCartColorId() >= 100 && cart.getCartColorId() <= 102) {
							// 购买牙刷
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp = new CartDto();
								BeanUtils.copyProperties(cart, temp);
								cartMap.put(cart.getCartProductId(), temp);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						flag = false;
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponItemDto.getCouponReduce()) {
							couponItemDto.setCouponReduce(cart.getProductPrice());
						}
					});
					if (couponItemDto.getCouponReduce() <= 0) {
						flag = false;
					}
					break;
                case 500006:
					// 青春版牙刷 买一送一
					cartMap = new HashMap<>(tempCarts.size());
					for (int i = 0; i < tempCarts.size(); i++) {
						CartDto cart = tempCarts.get(i);
						if (cart.getCartColorId() >= 369 && cart.getCartColorId() <= 370) {
							// 购买牙刷
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp = new CartDto();
								BeanUtils.copyProperties(cart, temp);
								cartMap.put(cart.getCartProductId(), temp);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						flag = false;
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponItemDto.getCouponReduce()) {
							couponItemDto.setCouponReduce(cart.getProductPrice());
						}
					});
					if (couponItemDto.getCouponReduce() <= 0) {
						flag = false;
					}
					break;
                case 500007:
					// R系列牙刷 买一送一
					cartMap = new HashMap<>(tempCarts.size());
					for (int i = 0; i < tempCarts.size(); i++) {
						CartDto cart = tempCarts.get(i);
						if (cart.getCartColorId() >= 60 && cart.getCartColorId() <= 63) {
							// 购买牙刷
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp = new CartDto();
								BeanUtils.copyProperties(cart, temp);
								cartMap.put(cart.getCartProductId(), temp);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						flag = false;
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponItemDto.getCouponReduce()) {
							couponItemDto.setCouponReduce(cart.getProductPrice());
						}
					});
					if (couponItemDto.getCouponReduce() <= 0) {
						flag = false;
					}
					break;
                case 500008:
					// Kids系列牙刷 买一送一
					cartMap = new HashMap<>(tempCarts.size());
					for (int i = 0; i < tempCarts.size(); i++) {
						CartDto cart = tempCarts.get(i);
						if (cart.getCartColorId() >= 76 && cart.getCartColorId() <= 77) {
							// 购买牙刷
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp = new CartDto();
								BeanUtils.copyProperties(cart, temp);
								cartMap.put(cart.getCartProductId(), temp);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						flag = false;
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponItemDto.getCouponReduce()) {
							couponItemDto.setCouponReduce(cart.getProductPrice());
						}
					});
					if (couponItemDto.getCouponReduce() <= 0) {
						flag = false;
					}
					break;
				default:
					//达到优惠券所设置的金额
					if(total >= couponItemDto.getCouponConsumeEnough()){
						//需要购买牙刷到某种金额
						if(toothbrushTotal <  couponItemDto.getCouponToothbrushEnough()){
							flag = false;
						}
					}else{
						flag = false;
					}
					break;
			}
			if(flag){
				list.add(couponItemDto);
			}
		}
		/*插入优惠券*/
		if(channelType <= 0 && channelId <= 0){
			dto.setCouponItems(list);
		}

		dto.setCartId(cartIds);// 购物车ID
		dto.setPayTotal(total); // 支付金额,单位为分
		dto.setIsCustomize("1");//判断是否为定制牙刷
		dto.setCartItems(tempCarts); // 订单项
		dto.setSuccess(true); // 请求成功
		dto.setMeonyProportion(0);

		//回显用户支付过的地址信息
		Order order=cartService.getOrderRecentAddress(member.getUserOpenid());

		if(order!=null){
			HashMap<String,String> map = new HashMap<String,String>();
			//map.put("orderId", order.getSalesOrderid());
			map.put("salesAddressName", order.getSalesAddressName());
			map.put("salesAddressInfo", order.getSalesAddressInfo());
			map.put("salesAddressTel", order.getSalesAddressTel());
			map.put("salesAddressPostnum", order.getSalesAddressPostnum());
			dto.setAddressInfo(map);
		}

		msg.setResultCode(ResultInfo.SUCCESSCODE);
		msg.setMessage(NameUtils.getConfig("SUCCESSINFO"));
		msg.setData(dto);
		msg.setStatus(true);

		return msg;
	}


	/**
	 * 发起支付请求
	 * @return
	 * @throws Exception
	 */
	@ResponseBody
	@RequestMapping(value = "/pay", method = RequestMethod.POST)
	public ResultMsg requestPay(TempOrderDto temp, HttpServletRequest request) throws Exception {
		// 返回信息
		ResultMsg msg = new ResultMsg();
		msg.setResultCode(ResultInfo.ERRORCODE);
		//当前支付时间
		Date nowDate = new Date();
		// 支付信息
		SendPayDto dto = new SendPayDto();
		dto.setSuccess(false);
		/** 数据格式校验 */
		Member member = memberService.getMemberByUserId(WechatUtils.getUserBySession(request).getUserId());
		if (!validatorUtil.validatorObject(temp)) {
			// 校验订单信息是否输入有误
			msg.setMessage(ResultInfo.paramFormatError);
			return msg;
		}
		/*校验订单信息*/
		if(temp.getOrderAddressMoblie() == null || "".equals(temp.getOrderAddressMoblie())){
			msg.setMessage("电话号码为空，请重新添加收货地址信息！");
			return msg;
		}
		if(temp.getOrderAddressMoblie().length() != 11){
			msg.setMessage("电话号码错误，请重新添加收货地址信息！");
			return msg;
		}
		if(temp.getOrderAddressName() == null || "".equals(temp.getOrderAddressName())){
			msg.setMessage("收货人姓名为空，请重新添加收货地址信息！");
			return msg;
		}
		if(temp.getCartIdStr() == null || "".equals(temp.getCartIdStr())){
			msg.setMessage("未选择商品，请重新选择商品并结算！");
			return msg;
		}
		if(temp.getOrderUserRemark() != null){
			if (temp.getOrderUserRemark().length() > 100) {
				msg.setMessage("备注只能输入100个字符");
				return msg;
			}
		}
		// 如果是非自提订单，判断是否有收货信息
		if(temp.getSalesTransportationType() == 1){
			if(temp.getOrderAddressInfo() == null || "".equals(temp.getOrderAddressInfo())){
				msg.setMessage("收货人地址为空，请重新添加收货地址信息！");
				return msg;
			}
		}
		// 是否购买定制牙刷（1表示普通牙刷、2表示定制牙刷
		if(temp.getIsCustomize() == null || "".equals(temp.getIsCustomize())){
			//默认为1
			temp.setIsCustomize("1");
		}

		//活动内容
		ActivityDate activityDate = activityUtil.doubleTwelve();
		Integer [] cartId = null;
		try {
			cartId = checkCartIdListString(temp.getCartIdStr());
		} catch (Exception e) { // 一旦发生异常，表示错误
			msg.setMessage(ResultInfo.paramFormatError);
			return msg;
		}
		List<CartDto> cartDtos = cartService.selectCartItemByListId(cartId);


		//牙刷个数
		Integer toothAllbrush = 0;
		//成人牙刷个数
		Integer toothAuthbrush = 0;
		//儿童牙刷个数
		Integer toothKidsbrush = 0;
		//lips牙刷刷头数量 - 单只
		Integer toothLipsbrushHeadNum = 0;
		//北欧和轻奢刷头数量 - 单只
		Integer toothRPbrushHeadNum = 0;
		//儿童刷头数量 - 单只
		Integer toothKidbrushHeadNum = 0;
		//组合套装刷头数量
		Integer toothComBinbrushHeadNum = 0;
		// 牙刷总金额  - 判断 需要购买牙刷到某种金额
		Integer brushelTotal = 0;
		// 刷头总金额
		Integer brushHeadTotal = 0;
		//刷头抵扣券，能够优惠的价格
	    int brushelCouponTotal = 0;
		//lips刷头抵扣券，能够优惠的价格
	    int brushelLipsCouponTotal = 0;

		if(temp.getChannelType() > 0 && temp.getChannelId() > 0){
			//非分销渠道，才能有促销
			activityDate.setStatus(false);
		}else {
			if (activityDate.isStatus()) {
				//满赠
				giftCart(cartDtos);
			}
		}

		if (cartDtos == null || cartDtos.size() <= 0) {
			// 根据购物车ID，查询数据库中对应的产品信息（ID、产品状态）
			msg.setMessage(ResultInfo.cartEmptyError);
			return msg;
		}
		//是否有上朵分销商品
		boolean isChannelProduct = false;
		// 需要支付的总额, 单位为分
		int total = 0;
		// 如果有分销，此值为分销总额，没有就与total值等同
		int channelTotal = 0;

		//穿件订单
		Order order = new Order();
		order.setSalesOrderid(OrderNOUtil.createOrderCode(member.getUserId()));
		List<OrderItem> list = new ArrayList<OrderItem>();
		List<Integer> cartIds = new ArrayList<Integer>();
		for (CartDto cartDto : cartDtos) {
			if (cartDto.getProductStatus() != null && cartDto.getProductStatus() == 1) {
				cartIds.add(cartDto.getCartId());
				// 小计
				Integer subTotal = cartDto.getCartNum() * cartDto.getProductPrice();
				Integer discount = 0,price=0;
				total += subTotal;

				/*上朵分销，*/
				if(temp.getChannelType() > 0 && temp.getChannelId() > 0){
					ChannelPrice channelPrice = channelPriceService.getChannelPriceByChannel(temp.getChannelId(),temp.getChannelType(),cartDto.getCartColorId());
					if(channelPrice != null){
						subTotal = cartDto.getCartNum() * channelPrice.getChannelPriceOffer();
						discount = channelPrice.getChannelPriceOffer();
						price =channelPrice.getChannelOriginalPrice();
						//上朵分销减价
						isChannelProduct = true;
					}
				}
				channelTotal += subTotal;

				OrderItem item = new OrderItem();
				item.setItemNum(cartDto.getCartNum());

				if(discount > 0 ){
					item.setItemProductDiscount(discount);
				}else{
					item.setItemProductDiscount(cartDto.getProductPrice());
				}

				item.setItemProductId(cartDto.getCartProductId());
				item.setItemProductName(cartDto.getProductName());
				item.setItemProductPic(cartDto.getProductIntroduceImg());
				item.setItemSalesOrderid(order.getSalesOrderid());
				item.setItemTotal(subTotal);
				item.setItemProductType(cartDto.getProductType());
				if(price > 0 ){
					item.setItemProductPrice(price);
				}else{
					item.setItemProductPrice(cartDto.getProductDiscount());
				}

				item.setItemColorId(cartDto.getCartColorId());
				list.add(item);

				switch (cartDto.getColorToothType()){
					//牙刷分类
					case 1:
						//1：赠品(非牙刷，非刷头)
						break;
					case 2:
						//2：成人牙刷
						toothAuthbrush += cartDto.getCartNum();
						toothAllbrush += cartDto.getCartNum();
						brushelTotal += subTotal;
						break;
					case 3:
						// 3：儿童牙刷
						toothKidsbrush += cartDto.getCartNum();
						toothAllbrush += cartDto.getCartNum();
						brushelTotal += subTotal;
						break;
					case 4:
						//4：亲子款（成人+儿童）
						toothAllbrush += cartDto.getCartNum();
						brushelTotal += subTotal;
						break;
					case 5:
						//5：刷头(lips)
						toothLipsbrushHeadNum += cartDto.getCartNum();
						brushHeadTotal += subTotal;
						if(brushelLipsCouponTotal == 0 || brushelLipsCouponTotal < cartDto.getProductPrice()){
							brushelLipsCouponTotal = cartDto.getProductPrice();
						}
						break;
					case 6:
						//6:刷头(儿童)
						toothKidbrushHeadNum += cartDto.getCartNum();
						brushHeadTotal += subTotal;
						if(brushelCouponTotal == 0 || brushelCouponTotal < cartDto.getProductPrice()){
							brushelCouponTotal = cartDto.getProductPrice();
						}
						break;
					case 7:
						//7:刷头(北欧+轻奢)
						toothRPbrushHeadNum += cartDto.getCartNum();
						brushHeadTotal += subTotal;
						if(brushelCouponTotal == 0 || brushelCouponTotal < cartDto.getProductPrice()){
							brushelCouponTotal = cartDto.getProductPrice();
						}
						break;
					case 8:
						//8:刷头(套装)
						brushHeadTotal += subTotal;
						toothComBinbrushHeadNum += cartDto.getCartNum();
						break;
					default:
						break;
				}
			}else if(cartDto.getProductStatus() != 1){
				msg.setMessage(ResultInfo.cartNoStatusError);
				return msg;
			}
		}

		// 准备订单对象
		order.setSalesOpenid(member.getUserOpenid());
		order.setSalesAmount(total);

		if(total > channelTotal && temp.getChannelType() > 0 && temp.getChannelId() > 0){
			//如果有分销优惠，将直接使用分销优惠价
			total = channelTotal;
		}

		int mustPay=0;

		String couponId=temp.getCouponId();
		CouponItemDto couponItemDto=new CouponItemDto();
		CouponItem couponItem=new CouponItem();
		boolean hasCoupon=false;
		//获取优惠券不为空    上朵分销不能使用优惠券
		if(couponId!=null && !"".equals(couponId) && !isChannelProduct){
			hasCoupon=true;
			//查询优惠券，获取对应的金额
			couponItemDto = couponItemService.getCouponItemById(couponId);
			couponItem.setCouponId(couponItemDto.getCouponId());
			couponItem.setCouponItemId(couponItemDto.getCouponItemId());
			couponItem.setCouponItemRemark(couponItemDto.getCouponItemRemark());
			couponItem.setCouponItemUseropenid(couponItemDto.getUseropenid());
			couponItem.setCouponUseEndDate(couponItemDto.getCouponUseEndDate());
			couponItem.setCouponUseDate(couponItemDto.getCouponUseDate());
			couponItem.setCouponIsNewPeople(couponItemDto.getCouponIsNewPeople());

			if(null==couponItemDto || !couponItemDto.getUseropenid().equals(member.getUserOpenid()) || couponItemDto.getCouponUseStatus()!=1){
				//优惠券无效
				msg.setMessage(ResultInfo.COUPON_INVALID);
				return msg;
			}

			Date couponUseEndDate = couponItem.getCouponUseEndDate();
			Calendar nowTime = Calendar.getInstance();
			nowTime.setTime(couponUseEndDate);
			nowTime.set(Calendar.HOUR_OF_DAY, 23);
			nowTime.set(Calendar.MINUTE, 59);
			nowTime.set(Calendar.SECOND, 59);
			couponUseEndDate = nowTime.getTime();
			if(couponUseEndDate.getTime()<nowDate.getTime()){
				//优惠券过期
				msg.setMessage(ResultInfo.COUPON_OUTOFDATE);
				return msg;
			}
			//消费达到指定额度
			CouponType couponType = couponTypeService.getCouponTypeById(couponItemDto.getCouponId());
			if(couponType.getCouponConsumeEnough()>total){
				//消费额度不足
				msg.setMessage(ResultInfo.COUPON_CONSUME_NO_ENOUGH);
				return msg;
			}

			if(couponItemDto.getCouponIsUniversal() == 2){
				//判断部分产品能使用的优惠券
				if(!couponItemService.isUniversal(couponItemDto.getCouponId(),cartDtos)){
					//不满足优惠条件
					msg.setMessage(ResultInfo.COUPON_NO_TOOTH_AMOUNT);
					return msg;
				}
			}

			/*需要购买牙刷到某种金额*/
			if(brushelTotal <  couponItemDto.getCouponToothbrushEnough()){
				//100元现金券
				msg.setMessage(ResultInfo.COUPON_NO_TOOTH_AMOUNT);
				return msg;
			}
			Map<Integer, CartDto> cartMap = null;
			switch (couponType.getCouponId()){
				case 20000:
					//刷头抵扣卷
					if(member.getUserIdentity() != 1){
						if(toothAllbrush < 1){
							//非会员需要购买电动牙刷才能使用该优惠券
							msg.setMessage(ResultInfo.COUPON_NO_MEMBER);
							return msg;
						}
					}
					if(brushelCouponTotal > 0){
						total = total - brushelCouponTotal;
					}else if(brushelLipsCouponTotal > 0){
						total = total - brushelLipsCouponTotal;
					}
					break;
				case 20004:
					//lips刷头抵扣卷
					if(member.getUserIdentity() != 1){
						if(toothAllbrush < 1){
							//非会员需要购买电动牙刷才能使用该优惠券
							msg.setMessage(ResultInfo.COUPON_NO_MEMBER);
							return msg;
						}
					}
					total = total - brushelLipsCouponTotal;
					break;
				case 40000:
					//当券 新人卷    60元优惠券
					if(member.getUserIdentity() != 1){
						if(toothAllbrush < 1){
							//非会员需要购买电动牙刷才能使用该优惠券
							msg.setMessage(ResultInfo.COUPON_NO_MEMBER);
							return msg;
						}
					}
					//刷头总价减去优惠券金额  小于零（只需要减去刷头总价） 大于零（需要减去优惠券总价）
					int br = 0;
					br = brushHeadTotal - couponType.getCouponReduce();
					if(br <= 0){
						total = total - brushHeadTotal;
					}else{
						total = total - couponType.getCouponReduce();
					}
					break;
				case 110000:
					//上朵年货节-电动牙刷8折券
					int itemBrush = brushelTotal*couponType.getCouponReduce()/100;
					total = total-brushelTotal+itemBrush;
					break;
				case  110001:
					//上朵年货节-刷头9折券
				case  110002:
					//上朵年货节-刷头8.5折券
				case  110003:
					//上朵年货节-刷头8折券
				case  110004:
					//上朵年货节-刷头7.5折券
					int itemBrushHead = brushHeadTotal*couponType.getCouponReduce()/100;
					total = total-brushHeadTotal+itemBrushHead;
					break;
				case 110005:
					// 牙刷买1送1(寻找两个以上的牙刷，单价最高)
					cartMap = new HashMap<>(cartDtos.size());
					for (int i = 0; i < cartDtos.size(); i++) {
						CartDto cart = cartDtos.get(i);
						if (cart.getColorToothType() >= 2 && cart.getColorToothType() <= 4) {
							// 购买牙刷
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp1 = new CartDto();
								BeanUtils.copyProperties(cart, temp1);
								cartMap.put(cart.getCartProductId(), temp1);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponType.getCouponReduce()) {
							couponType.setCouponReduce(cart.getProductPrice());
						}
					});
					total=total-couponType.getCouponReduce();
					break;
				case 500004:
					// P系列牙刷(买一送一)
					cartMap = new HashMap<>(cartDtos.size());
					for (int i = 0; i < cartDtos.size(); i++) {
						CartDto cart = cartDtos.get(i);
						if (cart.getColorToothType() >= 42 && cart.getColorToothType() <= 45) {
							// 购买牙刷
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp1 = new CartDto();
								BeanUtils.copyProperties(cart, temp1);
								cartMap.put(cart.getCartProductId(), temp1);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponType.getCouponReduce()) {
							couponType.setCouponReduce(cart.getProductPrice());
						}
					});
					total=total-couponType.getCouponReduce();
					break;
				case 500005:
					// Lips系列牙刷(买一送一)
					cartMap = new HashMap<>(cartDtos.size());
					for (int i = 0; i < cartDtos.size(); i++) {
						CartDto cart = cartDtos.get(i);
						if (cart.getColorToothType() >= 100 && cart.getColorToothType() <= 102) {
							// 购买牙刷
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp1 = new CartDto();
								BeanUtils.copyProperties(cart, temp1);
								cartMap.put(cart.getCartProductId(), temp1);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponType.getCouponReduce()) {
							couponType.setCouponReduce(cart.getProductPrice());
						}
					});
					total=total-couponType.getCouponReduce();
					break;
				case 500006:
					// 青春版牙刷(买一送一)
					cartMap = new HashMap<>(cartDtos.size());
					for (int i = 0; i < cartDtos.size(); i++) {
						CartDto cart = cartDtos.get(i);
						if (cart.getColorToothType() >= 369 && cart.getColorToothType() <= 370) {
							// 购买牙刷
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp1 = new CartDto();
								BeanUtils.copyProperties(cart, temp1);
								cartMap.put(cart.getCartProductId(), temp1);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponType.getCouponReduce()) {
							couponType.setCouponReduce(cart.getProductPrice());
						}
					});
					total=total-couponType.getCouponReduce();
					break;
				case 500007:
					// R系列牙刷(买一送一)
					cartMap = new HashMap<>(cartDtos.size());
					for (int i = 0; i < cartDtos.size(); i++) {
						CartDto cart = cartDtos.get(i);
						if (cart.getColorToothType() >= 60 && cart.getColorToothType() <= 63) {
							// 购买牙刷
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp1 = new CartDto();
								BeanUtils.copyProperties(cart, temp1);
								cartMap.put(cart.getCartProductId(), temp1);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponType.getCouponReduce()) {
							couponType.setCouponReduce(cart.getProductPrice());
						}
					});
					total=total-couponType.getCouponReduce();
					break;
				case 500008:
					// Kids系列牙刷(买一送一)
					cartMap = new HashMap<>(cartDtos.size());
					for (int i = 0; i < cartDtos.size(); i++) {
						CartDto cart = cartDtos.get(i);
						if (cart.getColorToothType() >= 76 && cart.getColorToothType() <= 77) {
							// 购买牙刷
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp1 = new CartDto();
								BeanUtils.copyProperties(cart, temp1);
								cartMap.put(cart.getCartProductId(), temp1);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponType.getCouponReduce()) {
							couponType.setCouponReduce(cart.getProductPrice());
						}
					});
					total=total-couponType.getCouponReduce();
					break;
				case 110006:
					// 刷头买1送1(寻找单价最高的刷头，2个以上)
					cartMap = new HashMap<>(cartDtos.size());
					for (int i = 0; i < cartDtos.size(); i++) {
						CartDto cart = cartDtos.get(i);
						if (cart.getColorToothType() >= 5 && cart.getColorToothType() <= 8) {
							// 购买刷头
							CartDto cartDto = cartMap.get(cart.getCartProductId());
							if (cartDto == null) {
								CartDto temp1 = new CartDto();
								BeanUtils.copyProperties(cart, temp1);
								cartMap.put(cart.getCartProductId(), temp1);
							} else {
								cartDto.setCartNum(cartDto.getCartNum() + cart.getCartNum());
							}
						}
					}
					if (cartMap.isEmpty()) {
						break;
					}
					cartMap.forEach((key, cart) -> {
						if (cart.getCartNum() >= 2 && cart.getProductPrice().intValue() > couponType.getCouponReduce()) {
							couponType.setCouponReduce(cart.getProductPrice());
						}
					});
					total=total-couponType.getCouponReduce();
					break;
				default:
					//优惠券的类型，是直接减免额度 还是折扣价
					if(couponType.getCouponType()==1){
						total=total-couponType.getCouponReduce();
					}else if(couponType.getCouponType()==2){
						total=total*couponType.getCouponReduce()/100;
					}
					break;
			}
		}
		if(total==0 || total<0){
			total=0;
			mustPay=0;
		}else{
			mustPay=total;
		}

		//双十二期间，全场满328元减50元，全场满499元减100元，全场满满699元减150元
		if (activityDate.isStatus()) {
			/*满减*/
			Integer promotionAmout = fullReduc(activityDate,cartDtos);
			mustPay -= promotionAmout;
		}

		Integer salesPostage = 0;
		//当总金额小于30 的时候，不包邮，需要10块钱邮费
		if(mustPay < 3000){
			salesPostage = 1000;
			mustPay = mustPay+1000;
		}

		order.setSalesYetAmount(mustPay);
		order.setSalesRateAmount(0);
		order.setSalesIntegralNum(0); // 订单使用积分
		order.setSalesCreateDate(new Date()); // 创建时间
		order.setBalancePayAmount(0); //账户余额支付金额
		order.setCouponId(couponId);   //优惠券id
		order.setSalesPostage(salesPostage);	//邮费金额

		order.setSalesStatus(1); // 待支付订单
		order.setSalesTransactionDate(nowDate);  //事务时间
		order.setSalesTransactionId("8990"+nowDate.getTime());
		order.setSalesAddressInfo(temp.getOrderAddressInfo()); // 收货地址
		order.setSalesAddressName(temp.getOrderAddressName()); // 收货人
		order.setSalesAddressTel(temp.getOrderAddressMoblie()); // 收入联系方式
		order.setSalesAddressPostnum(temp.getOrderAddressPostNum()); // 物流编号
		order.setSalesUserRemark(temp.getOrderUserRemark()); // 用户备注

		order.setSalesChannelId(temp.getChannelId());
		order.setSalesChannelType(temp.getChannelType());
		order.setSalesTransportationType(temp.getSalesTransportationType());	//salesTransportationType	订单运输类型  1:邮寄  2:自提

		if(temp.getSalesTransportationType() == 2){
			if(temp.getChannelType() == 1){
				MainChannel mainChannel = mainChannelService.getMainChannelById(temp.getChannelId());
				order.setSalesChannelAddress(mainChannel.getMainChannelName());	//salesChannelAddress
			}else if(temp.getChannelType() == 2){
				ChildChannel childChannel = childChannelService.getChildChannelById(temp.getChannelId());
				order.setSalesChannelAddress(childChannel.getChildChannelName());
			}
		}

		// 保存
		boolean flag = false;
		try {
			flag = cartService.addOrderAndSaveOrderItem(order, list, cartIds, temp.getIsCustomize());
			//修改优惠券状态为临时状态
			if(hasCoupon){
				couponItem.setCouponUseStatus(7);
				couponItemService.updateCouponItemById(couponItem);
			}

			/*分销添加返利 -- start */
			List<OrderItem> orderItemList = adminOrderService.getShopOrderItemByOrderId(order.getSalesOrderid());
			try{
				for (OrderItem oi:orderItemList) {
					if(temp.getChannelType() > 0 && temp.getChannelId() > 0){
						ChannelPrice channelPrice = channelPriceService.getChannelPriceByChannel(temp.getChannelId(),temp.getChannelType(),oi.getItemColorId());
						if(channelPrice != null){
							Integer rebateAmount = channelPrice.getChannelRebateAmount();	//channelRebateAmount  返利金额
							rebateAmount = rebateAmount * oi.getItemNum();

							ChannelRebate channelRebate = new ChannelRebate();
							channelRebate.setRebateSalesOrderId(order.getSalesOrderid());
							channelRebate.setRebackFromOpenId(member.getUserOpenid());
							channelRebate.setRebateItemId(oi.getItemId());
							channelRebate.setRebackChannelType(temp.getChannelType());
							channelRebate.setRebackChannelId(temp.getChannelId());
							channelRebate.setRebackAmount(rebateAmount);
							channelRebate.setRebackStatus(1); 	//1:待返利
							Integer fl = channelRebateService.save(channelRebate);
							if(fl < 1){
								ratFWLogger.info("返利生成失败！失败订单号："+order.getSalesOrderid());
							}
						}
					}
				}
			}catch (Exception e){
				ratFWLogger.info("返利生成错误！失败订单号："+order.getSalesOrderid());
				e.printStackTrace();
			}
			/*分销添加返利 -- end */
		} catch (Exception e) {
			flag = false;
			System.out.println("====插入订单列表信息失败====");
			e.printStackTrace();
			msg.setMessage(ResultInfo.paramFormatError);
			return msg;
		}

		boolean updateFlase=false;
		if (flag && mustPay>0) {
			// 发起支付
			PayResult result = payService.requestPay(order.getSalesOpenid(), order.getSalesOrderid(), mustPay, list.get(0).getItemProductName() + "...", NameUtils.getConfig("WECHAT_ORDER_BACK"));
			System.out.println("支付返回result="+result.getPayData());
			if (result.isPaySuccess()) {
				dto.setInfo(result.getPayData());
				dto.setSuccess(true);
				dto.setOrderId(order.getSalesOrderid());
				updateFlase=false;
			} else {
				dto.setInfo(result.getPayData());
				dto.setOrderId(order.getSalesOrderid());
				msg.setResultCode(ResultInfo.ERRORCODE);
				msg.setMessage(NameUtils.getConfig("ERRORINFO"));
				msg.setData(dto);
				msg.setStatus(false);
				return msg;
			}
		} else if(flag && mustPay==0){
			dto.setInfo("isOK");
			dto.setSuccess(true);
			dto.setOrderId(order.getSalesOrderid());
			updateFlase=true;
		}else{
			msg.setMessage(ResultInfo.paramFormatError);
			return msg;
		}

		if(updateFlase){
			List<OrderItem> orderItemList = adminOrderService.getShopOrderItemByOrderId(order.getSalesOrderid());
			/*调整库存*/
			for (int i = 0; i < orderItemList.size(); i++) {
				Integer fl = productColorService.updateAddSoldNum(orderItemList.get(i).getItemColorId(),orderItemList.get(i).getItemNum());
 				if (fl < 1) {
					ratFWLogger.info("售出修改数量失败，订单号为:" +orderItemList.get(i).getItemSalesOrderid() );
				}else{
					ratFWLogger.info("售出修改数量成功，订单号为:" +orderItemList.get(i).getItemSalesOrderid()
							+";颜色id为："+orderItemList.get(i).getItemColorId()+"的数量减去"+orderItemList.get(i).getItemNum());
				}
			}
			/*调整库存*/

			//设置订单状态，还有优惠券id
			order.setSalesStatus(2);
			cartService.updateOrderStatus(order);
			//修改优惠券状态
			if(hasCoupon){
				couponItem.setCouponUseStatus(2);
				couponItem.setCouponUseDate(new Date());//添加使用时间
				int i=couponItemService.updateCouponItemById(couponItem);
			}
			productInfoService.updateProductNumList(order.getSalesOrderid());
		}
		msg.setResultCode(ResultInfo.SUCCESSCODE);
		msg.setMessage(NameUtils.getConfig("SUCCESSINFO"));
		dto.setOrderId(order.getSalesOrderid());
		msg.setData(dto);
		msg.setStatus(true);

		return msg;
	}

	/**
	 * 校验订单状态，判断是否支付成功
	 * @param orderId
	 * @return
	 */
	@ResponseBody
	@RequestMapping(value = "/checkOrderPaySuccess")
	public ResultMsg checkOrderPaySuccess(HttpServletRequest request,
			@RequestParam(value = "orderId") String orderId) {
		Member member = WechatUtils.getUserBySession(request); // 当前用户
		ResultMsg msg = new ResultMsg();
		msg.setResultCode(ResultInfo.ERRORCODE);
		Integer orderStatus = cartService.selectOrderStatusByOrderId(orderId);
		if (orderStatus != null && orderStatus.intValue() == 2) {
			msg.setResultCode(ResultInfo.SUCCESSCODE);
			msg.setMessage(NameUtils.getConfig("SUCCESSINFO"));
			msg.setData(orderId);
			msg.setStatus(true);
			return msg;
		}
		msg.setResultCode(ResultInfo.ERRORCODE);
		msg.setMessage(NameUtils.getConfig("ERRORINFO"));
		msg.setData(orderId);
		msg.setStatus(false);
		return msg;
	}

	/**
	 * 获取订单支付的积分
	 * @param orderId
	 * @return
	 */
	@ResponseBody
	@RequestMapping(value = "/getOrderIntegral")
	public ResultMsg getOrderIntegral(HttpServletRequest request,@RequestParam(value = "orderId") String orderId) {
		Member member = WechatUtils.getUserBySession(request); // 当前用户
		ResultMsg msg = new ResultMsg();
		msg.setResultCode(ResultInfo.ERRORCODE);
		//Integer orderStatus = cartService.selectOrderStatusByOrderId(orderId);
		if(orderId == null || "".equals(orderId)){
			msg.setResultCode(ResultInfo.ERRORCODE);
			msg.setMessage(NameUtils.getConfig("未查询到订单信息！"));
			msg.setStatus(false);
			return msg;
		}
		StayIntegral stayIntegral = new StayIntegral();
		stayIntegral.setOrderId(orderId);
		List<StayIntegral>  listStayIntegral = useIntegralService.listStayIntegral(stayIntegral);
		if (listStayIntegral != null && listStayIntegral.size() > 0) {
			msg.setResultCode(ResultInfo.SUCCESSCODE);
			msg.setMessage(NameUtils.getConfig("SUCCESSINFO"));
			msg.setData(listStayIntegral.get(0).getStayNumber());
			msg.setStatus(true);
			return msg;
		}else{
			msg.setResultCode(ResultInfo.SUCCESSCODE);
			msg.setMessage(NameUtils.getConfig("SUCCESSINFO"));
			msg.setData(0);
			msg.setStatus(true);
			return msg;
		}
	}

	@RequestMapping("/paySuccess")
	public void paySuccess(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		request.getRequestDispatcher(NameUtils.getConfig("WECHAT_SHOP_ORDER_PAY_SUCCESS")).forward(request, response);
	}

	@RequestMapping(value = "/getOrderInfo", method = RequestMethod.POST)
	@ResponseBody
	public ResultMsg getOrderInfoByOrderId(
			HttpServletRequest request,
			@RequestParam(value = "orderId") String orderId) throws Exception {
		ResultMsg msg = new ResultMsg();
		msg.setResultCode(ResultInfo.ERRORCODE);
		Member member = WechatUtils.getUserBySession(request); // 当前用户
		Order order = new Order();
		order.setSalesOrderid(orderId);
		order.setSalesOpenid(member.getUserOpenid());
		order = cartService.selectOrderInfoById(order);

		if (order == null || order.getSalesStatus() != 2) {
			msg.setMessage(ResultInfo.paramFormatError);
			return msg;
		}

		msg.setData(order);
		msg.setResultCode(ResultInfo.SUCCESSCODE);
		msg.setMessage(NameUtils.getConfig("SUCCESSINFO"));
		msg.setStatus(true);
		return msg;
	}

	/**
	 * 校验一个购物车字符串
	 * @param cartIds 购物车ID字符串
	 * @return
	 * @throws Exception
	 */
	public Integer[] checkCartIdListString(String cartIds) throws Exception {
		if (cartIds == null) {
			throw new Exception(ResultInfo.paramFormatError);
		}
		cartIds.trim();
		// split 购物车ID
		String [] cartList = cartIds.split("-");
		if (cartList == null || cartList.length <= 0) {
			throw new Exception(ResultInfo.paramFormatError);
		}
		// 转化 String 类型的购物车ID集合 --> Integer 类型的购物车集合
		Integer[] cartIntList = new Integer[cartList.length];
		for (int i = 0; i < cartList.length; i++) {
			String string = cartList[i];
			try {
				cartIntList[i] = Integer.parseInt(string);
			} catch (Exception e) {
				throw new Exception(ResultInfo.paramFormatError);
			}
		}
		if (cartIntList.length <= 0) {
			throw new Exception(ResultInfo.paramFormatError);
		}
		return cartIntList;
	}

	/**
	 * 满赠
		 1、买任意成人款牙刷送进口艾科弗牙膏
		 2、买任意儿童款牙刷（普通、派火车款,亲子款）加送儿童护齿书籍（进口艾科弗牙膏+儿童护齿书籍）
		 3、满499送进口艾科弗牙膏+进口Ora2漱口水（按实际支付金额）
		 4、满699元送进口艾科弗牙膏+MAC口红（按实际支付金额）
	 * @param type
	 * @param cartDtos
	 * @return
	 */
	private void addFullReduction(Integer type, List<CartDto> cartDtos,Integer num[]){
//		switch (type){
//			case 5 :
//				addCartDtos(cartDtos,322,1);//儿童护齿书籍
//				break;
//			case 4 :
//				addCartDtos(cartDtos,314,1);//牙膏
//				addCartDtos(cartDtos,321,1);//MAC口红
//				break;
//			case 3 :
//				addCartDtos(cartDtos,314,1);//牙膏
//				addCartDtos(cartDtos,315,1);//漱口水
//				break;
//			case 2 :
//				addCartDtos(cartDtos,314,1);//牙膏
//				addCartDtos(cartDtos,322,1);//儿童护齿书籍
//				break;
//			case 1 :
//				addCartDtos(cartDtos,314,num[0]);//牙膏
//				break;
//			default:
//				break;
//		}
	}

	/**
	 * 添加赠品
	 * @param
	 * @return
	 */
//	private void addCartDtos(List<CartDto> cartDtos,Integer id,Integer num){
//		boolean flag = false;
//		for (CartDto cartDto : cartDtos) {
//			if(id.equals(cartDto.getCartColorId())){
//				flag = true;
//			}
//		}
//		if(!flag){
//			CartDto cd = getGiftCartDtos(id,num);
//			cartDtos.add(cd);
//		}
//	}

	/**
	 * 获取赠品信息
	 * @param colorId
	 * @return
	 */
//	private CartDto getGiftCartDtos(Integer colorId,Integer num){
//		CartDto cartDto = new CartDto();
//		Product product = productInfoService.selectProductByColorId(colorId);
//		if((product.getColorSoldNum()+1) > product.getColorAllNum()){
//			return null;
//		}
//		cartDto.setCartId(1);
//		cartDto.setCartProductId(product.getProductId());
//		cartDto.setCartColorId(colorId);
//		cartDto.setCartNum(num);
//		cartDto.setProductName(product.getProductName());
//		cartDto.setProductType(product.getProductTypeId());
//		cartDto.setProductPrice(product.getColorDiscount());
//		cartDto.setProductStatus(1);
//		cartDto.setProductIntroduceImg(product.getColorImg());
//		cartDto.setTotal(0);
//		cartDto.setProductDiscount(product.getColorDiscount());
//		cartDto.setProductRemark(product.getColorPresent());
//		cartDto.setProductColor(product.getColorName());
//		cartDto.setColorAllNum(product.getColorAllNum());
//		cartDto.setColorSoldNum(product.getColorSoldNum());
//		cartDto.setIsSelfLifting(2);
//		return cartDto;
//	}


	/**
	 * 赠送赠品
	 * @param cartDtoList
	 */
	private void giftCart(List<CartDto> cartDtoList){
		List<CartDto> giftList = new ArrayList<>();
		SettlementGift settlementGift = new SettlementGift();
		settlementGift.setSettGiftStatus(1);
		List<SettlementGift> settlementGiftList = settlementGiftService.getSettlementGiftList(settlementGift);

		//2019年圣诞活动 -开始
		for (SettlementGift sg:settlementGiftList) {
			if(sg.getSettGiftId() == 50){
				Integer nownum = 0;
				for (CartDto cartDto:cartDtoList) {
					if(cartDto.getCartColorId() == 60 || cartDto.getCartColorId() == 61	||
							cartDto.getCartColorId() == 62 || cartDto.getCartColorId() == 63){		//60，61，62，63
						nownum += cartDto.getCartNum();
					}
				}
				if(nownum == 1){
					CartDto cartDto = new CartDto();
					cartDto.setCartColorId(361);
					cartDto.setCartNum(3);
					cartDto.setProductDiscount(0);
					cartDto.setProductPrice(0);
					cartDto.setTotal(0);
					giftList.add(cartDto);
				}else if(nownum >= 1){
					CartDto cartDto = new CartDto();
					cartDto.setCartColorId(361);
					cartDto.setCartNum(3);
					cartDto.setProductDiscount(0);
					cartDto.setProductPrice(0);
					cartDto.setTotal(0);
					giftList.add(cartDto);

					CartDto nowcartDto = new CartDto();
					nowcartDto.setCartColorId(316);
					nowcartDto.setCartNum(nownum - 1);
					nowcartDto.setProductDiscount(0);
					nowcartDto.setProductPrice(0);
					nowcartDto.setTotal(0);
					giftList.add(nowcartDto);
				}
			}
		}
		//2019年圣诞活动 - 结束

		for (CartDto cd:cartDtoList) {
			for (SettlementGift sg:settlementGiftList) {
				if(Objects.equals(cd.getCartColorId(), sg.getSettGiftFillColorId())){//添加赠送产品
					CartDto cartDto = new CartDto();
					cartDto.setCartColorId(sg.getSettGiftGiftColorId());
					Integer num = sg.getSettGiftNum();
					if(sg.getSettGiftNum() < 1){	//判断赠送数量，大于0就用该数量
						num = cd.getCartNum();
					}
					if(num > sg.getSettGiftMaxNum()){
						num = sg.getSettGiftMaxNum();
					}
					cartDto.setCartNum(num);
					cartDto.setProductDiscount(sg.getSettGiftPrice());
					cartDto.setProductPrice(sg.getSettGiftPrice());
					cartDto.setTotal(sg.getSettGiftPrice()*num);
					giftList.add(cartDto);
				}
			}
		}

		//赠品合并
		List<CartDto> newGiftList = new ArrayList<>();
		if(giftList != null && giftList.size() > 0){
			for (CartDto carD:giftList) {
				boolean fl = false;
				for(CartDto newCarD:newGiftList) {
					if(Objects.equals(newCarD.getCartColorId(), carD.getCartColorId())){	//赠品相同，合并
						fl = true;
						Integer oldNum = newCarD.getCartNum();
						newCarD.setCartNum(newCarD.getCartNum() + carD.getCartNum());
						if( newCarD.getCartNum() > newCarD.getColorGiftMaxNum()){	//（赠送数量+已售出<=总数）
							newCarD.setCartNum(newCarD.getColorGiftMaxNum());
						}
						Integer num = newCarD.getCartNum()+newCarD.getColorSoldNum();
						if(num > newCarD.getColorAllNum()){
							//newCarD.setCartNum(newCarD.getColorAllNum() - num);
							newCarD.setCartNum(oldNum);
						}

						newCarD.setProductDiscount(newCarD.getProductDiscount() +  carD.getProductDiscount());
						newCarD.setProductPrice( newCarD.getProductPrice() + carD.getProductPrice());
						newCarD.setTotal(newCarD.getTotal() + carD.getTotal());
					}
				}
				if(!fl){
					Product product = productInfoService.selectProductByColorId(carD.getCartColorId());
					carD.setCartId(1);
					carD.setCartProductId(product.getProductId());
					carD.setProductName(product.getProductName());
					carD.setProductType(product.getProductTypeId());
					carD.setProductStatus(1);
					carD.setProductIntroduceImg(product.getColorImg());
					carD.setProductRemark(product.getColorPresent());
					carD.setProductColor(product.getColorName());
					carD.setCartColorId(product.getColorId());
					carD.setProductRemark("");
					carD.setColorAllNum(product.getColorAllNum());
					carD.setColorSoldNum(product.getColorSoldNum());
					carD.setColorToothType(1);
					carD.setProductIntroduceImg(product.getColorImg());	//productIntroduceImg
					carD.setColorGiftMaxNum(product.getColorGiftMaxNum());
					if( carD.getCartNum() > carD.getColorGiftMaxNum()){	//（赠送数量+已售出<=总数）
						carD.setCartNum(carD.getColorGiftMaxNum());
					}
					Integer num = carD.getCartNum()+carD.getColorSoldNum();
					if(num <= carD.getColorAllNum()){	//库存加赠品数量  要小于 总库存才能到结算页面
						CartDto newCartDto = new CartDto();
						BeanUtils.copyProperties(carD,newCartDto);
						newGiftList.add(newCartDto);
					}
				}
			}
		}

		//将赠品并入结算列表
		if(newGiftList != null && newGiftList.size() > 0){
			cartDtoList.addAll(newGiftList);
		}
	}

	/**
	 * 满减
	 * @return
	 */
	public Integer fullReduc(ActivityDate activityDate,List<CartDto> cartDtos){
		Integer promotionAmout = 0;
		SalesActivities sa = new SalesActivities();
		sa.setSalesActivitiesStatus(1);
		sa.setSalesActivitiesType(activityDate.getType());
		List<SalesActivities> salesActivitiesList = salesActivitiesService.getSalesActivitiesList(sa);
		activityDate.setSalesActivitiesList(salesActivitiesList);
		for (SalesActivities salesActivities : salesActivitiesList){
			if(salesActivities.getSalesActivitiesScenes() == 2){

				if(salesActivities.getSalesActivitiesId() == 10){	//活动10专用 //圣诞活动，R系列一件减去90，两件打6.5折，因数据库设计过于复杂，只好在这写了
					Integer num = 0;
					Integer sunAmount = 0;
					for (CartDto cartDto:cartDtos) {
						if(cartDto.getCartColorId() == 60 || cartDto.getCartColorId() == 61	||
								cartDto.getCartColorId() == 62 || cartDto.getCartColorId() == 63){		//60，61，62，63
							num += cartDto.getCartNum();
							sunAmount += cartDto.getCartNum() * cartDto.getProductPrice();
						}
					}
					if(num == 1){
						promotionAmout = 9000;
					}else if(num >= 2){
						sunAmount -= 29900;
						Double amount = Double.valueOf(sunAmount);
						BigDecimal bd1 = new BigDecimal(Double.toString(amount));
						BigDecimal bd2 = new BigDecimal(Double.toString(0.35));
						amount = bd1.multiply(bd2).doubleValue();
						promotionAmout = amount.intValue();
						promotionAmout+=9000;
					}
				}

			}else{
				if(promotionAmout >= salesActivities.getSalesActivitiesFull()){
					promotionAmout = salesActivities.getSalesActivitiesReduction();
					break;
				}
			}
		}
		return promotionAmout;
	}
}
