<%@ page language="java" contentType="text/html; charset=UTF-8"
         pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="renderer" content="webkit|ie-comp|ie-stand">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width,initial-scale=1,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no" />
    <meta http-equiv="Expires" content="0">
    <meta http-equiv="Pragma" content="no-cache">
    <meta http-equiv="Cache-control" content="no-cache">
    <meta http-equiv="Cache" content="no-cache">
    <link href="${pageContext.request.contextPath }/common/admin/css/H-ui.min.css" rel="stylesheet" type="text/css" />
    <link href="${pageContext.request.contextPath }/common/admin/css/H-ui.admin.css" rel="stylesheet" type="text/css" />
    <link href="${pageContext.request.contextPath }/common/admin/css/style.css" rel="stylesheet" type="text/css" />
    <link href="${pageContext.request.contextPath }/common/admin/lib/Hui-iconfont/1.0.1/iconfont.css" rel="stylesheet" type="text/css" />
    <title>生产批次二维码列表</title>
    <style>
        .exp1{font-size:18px;}
    </style>
</head>
<body>
<nav class="breadcrumb">
    <i class="Hui-iconfont">&#xe67f;</i>
    首页 <span class="c-gray en">&gt;</span>
    质保卡管理 <span class="c-gray en">&gt;</span>
    质保卡列表
    <a class="btn btn-success radius r mr-20" style="line-height: 1.6em; margin-top: 3px" href="javascript:location.replace(location.href);" title="刷新">
        <i class="Hui-iconfont">&#xe68f;</i></a>
</nav>
<div class="pd-20">
    <div class="text-c">
        <form action="${pageContext.request.contextPath }/admin/qrCode/select_card_list" method="post" id="myForm">
            <input type="text" name="cardBarcode" id="cardBarcode" value="${cardBarcode }" placeholder="质保卡号" style="width: 150px" class="input-text">
            <input type="text" name="userName" id="userName" value="${userName }" placeholder="姓名" style="width: 150px" class="input-text">
            <input type="text" name="userEmail" id="userEmail" value="${userEmail }" placeholder="邮箱" style="width: 150px" class="input-text">
             <button name="" id="submitBtn" class="btn btn-success" type="submit">
                 <i class="Hui-iconfont">&#xe665;</i> 搜索
             </button>
        </form>
    </div>
    <div class="mt-20">
        <table class="table table-border table-bordered table-bg table-hover table-sort">
            <thead>
            <tr class="text-c">
                <th width="60">质保卡号</th>
                <th width="60">姓名</th>
                <th width="100">邮箱</th>
                <th width="60">水质范围</th>
                <th width="100">地址</th>
                <th width="60">购买日期</th>
                <th width="60">换新截止日期</th>
                <th width="60">十年质保日期</th>
            </tr>
            </thead>
            <tbody id="listid">
            <c:if test="${ !(empty cardList)}">
                <c:forEach items="${cardList}" var="card">
                    <tr>
                        <td class="text-c" width="60">${card.cardBarcode }</td>
                        <td class="text-c" width="60">${card.userName }</td>
                        <td class="text-c" width="60">${card.userEmail }</td>
                        <td class="text-c" width="60">
                            <c:if test="${card.cardWatero == 1 }">
                                0-100 TDS
                            </c:if>
                            <c:if test="${card.cardWatero == 2 }">
                                101-250 TDS
                            </c:if>
                            <c:if test="${card.cardWatero == 3 }">
                                251-500 TDS
                            </c:if>
                            <c:if test="${card.cardWatero == 4 }">
                                501 TDS 以上
                            </c:if>
                        </td>
                        <td class="text-c" width="100">${card.cardLocation }</td>
                        <td class="text-c" width="60"><fmt:formatDate value="${card.cardSaleTime }" pattern="yyyy-MM-dd" /></td>
                        <td class="text-c" width="60"><fmt:formatDate value="${card.cardRenewTime }" pattern="yyyy-MM-dd" /></td>
                        <td class="text-c" width="60"><fmt:formatDate value="${card.cardEndTime }" pattern="yyyy-MM-dd" /></td>
                    </tr>
                </c:forEach>
            </c:if>
            </tbody>
        </table>
    </div>
    <div align="right" style="padding-top: 10px;">
        <%@include file="/common/other/paper/pager.jsp"%>
    </div>
</div>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/jquery/1.9.1/jquery.min.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/layer/1.9.3/layer.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/My97DatePicker/WdatePicker.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.admin.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/jquery.PrintArea.js"></script>
<script type="text/javascript">

</script>
</body>
</html>